;This program compares a number in variable 'n' with a number set by variable 'border'
;-if n<border, print 'small', otherwise print 'large'
;-demonstrates:
;- simple arithmetic
;- decision making using JL instruction
;- use of INT 21 to write string
;- note use of 'word ptr' to inform assembler to work on a word rather than byte
;- note the layout preference of original author
;
;Original author: Ian Harries <ih@doc.ic.ac.uk>

        .MODEL SMALL    ; Data and code fit in one 64K segment
        .STACK       	; allocate a stack
		.CODE		; start of code segment

;       INT 21 - WRITE STRING TO STANDARD OUTPUT
;       AH = 09h
;       DS:DX -> '$'-terminated string
;       Return: AL = 24h (the '$' terminating the string)

border  equ 1000		;threshold for comparison

        ;***** setup DS register *****
        mov ax,@data		;point DS to data segment
        mov ds,ax

	;***** compare the two number and make decision *****
        cmp [n],word ptr border	;if n < border
        jl small		;then print "small"

large:				;else print "large"
        lea dx,mesg2		;DX=effective address (offset) of 'mesg2'
	mov ah,09h      	;function: print string        int 21h
        jmp done
              
small:				;print "small"
        lea dx,mesg1		;DX=effective address (offset) of 'mesg1'
	mov ah,09h		;function: print string
        int 21h     

done:   mov ax,4c00h		;exit to DOS with errorlevel 0
        int 21h

        .DATA

n       dw 999			;variable n
mesg1   db 'small$'
mesg2   db 'large$'

;TASK:
;1. TRY WITH DIFFERENT VALUES OF N
;2. SAVE THE PROGRAM AS SIZE1A.ASM AND EXTEND THIS NEW VERSION TO INCLUDE A "HUGE" REPORT
;   NUMBERS LARGER THAN 10000
;3. CAN YOU ACHIEVE SAME EFECT WITH FEWER INSTRUCTIONS? PERHAPS SOME ARE DUPLICATED UNNECESSARILY.
;   HAVE A GO AND THEN LOOK AT SIZE2.ASM (WILL BE PROVIDED LATER).  HOW DID YOU DO?

        end
